## Math 1 Group

p.floor <- function(x, P = 0) .Call("do_floor_v", x, P)
p.ceiling <- function(x, P = 0) .Call("do_ceil_v", x, P)
p.sqrt <- function(x, P = 0) .Call("do_sqrt_v", x, P)
p.sign <- function(x, P = 0) .Call("do_sign_v", x, P)

p.exp <- function(x, P = 0) .Call("do_exp_v", x, P)
p.expm1 <- function(x, P = 0) .Call("do_expm1_v", x, P)
p.log1p <- function(x, P = 0) .Call("do_log1p_v", x, P)
p.cos <- function(x, P = 0) .Call("do_cos_v", x, P)
p.sin <- function(x, P = 0) .Call("do_sin_v", x, P)
p.tan <- function(x, P = 0) .Call("do_tan_v", x, P)
p.acos <- function(x, P = 0) .Call("do_acos_v", x, P)
p.asin <- function(x, P = 0) .Call("do_asin_v", x, P)

p.cosh <- function(x, P = 0) .Call("do_cosh_v", x, P)
p.sinh <- function(x, P = 0) .Call("do_sinh_v", x, P)
p.tanh <- function(x, P = 0) .Call("do_tanh_v", x, P)
p.acosh <- function(x, P = 0) .Call("do_acosh_v", x, P)
p.asinh <- function(x, P = 0) .Call("do_asinh_v", x, P)
p.atanh <- function(x, P = 0) .Call("do_atanh_v", x, P)

p.lgamma <- function(x, P = 0) .Call("do_lgammafn_v", x, P)
p.gamma <- function(x, P = 0) .Call("do_gammafn_v", x, P)

p.digamma <- function(x, P = 0) .Call("do_digamma_v", x, P)
p.trigamma <- function(x, P = 0) .Call("do_trigamma_v", x, P)

p.gammaCody <- function(x, P = 0) .Call("do_gamma_cody_v", x, P)


## Math 2 Group

p.lbeta <- function(x, y, P = 0) .Call("do_lbeta_v", x, y, P)
p.beta <- function(x, y, P = 0) .Call("do_beta_v", x, y, P)
p.lchoose <- function(x, k, P = 0) .Call("do_lchoose_v", x, k, P)
p.choose <- function(x, k, P = 0) .Call("do_choose_v", x, k, P)

p.dchisq <- function(x, df, ncp = 0, log = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_dchisq_v", x, df, log, P)
    else .Call("do_dnchisq_v", x, df, ncp, log, P)
}
p.pchisq <- function(x, df, ncp = 0, lower.tail = TRUE, log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_pchisq_v", x, df, lower.tail, log.p, P)
    else .Call("do_pnchisq_v", x, df, ncp, lower.tail, log.p, P)
}
p.qchisq <- function(p, df, ncp = 0, lower.tail = TRUE, log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_qchisq_v", p, df, lower.tail, log.p, P)
    else .Call("do_qnchisq_v", p, df, ncp, lower.tail, log.p, P)
}

p.dexp <- function(x, rate = 1, log = FALSE, P = 0)
    .Call("do_dexp_v", x, 1/rate, log, P)
p.pexp <- function(x, rate = 1, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_pexp_v", x, 1/rate, lower.tail, log.p, P)
p.qexp <- function(p, rate = 1, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_qexp_v", p, 1/rate, lower.tail, log.p, P)

p.dgeom <- function(x, prob, log = FALSE, P = 0)
    .Call("do_dgeom_v", x, prob, log, P)
p.pgeom <- function(x, prob, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_pgeom_v", x, prob, lower.tail, log.p, P)
p.qgeom <- function(p, prob, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_qgeom_v", p, prob, lower.tail, log.p, P)

p.dpois <- function(x, lambda, log = FALSE, P = 0)
    .Call("do_dpois_v", x, lambda, log, P)
p.ppois <- function(x, lambda, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_ppois_v", x, lambda, lower.tail, log.p, P)
p.qpois <- function(p, lambda, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_qpois_v", p, lambda, lower.tail, log.p, P)

p.dt <- function(x, df, ncp = 0, log = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_dt_v", x, df, log, P)
    else .Call("do_dnt_v", x, df, ncp, log, P)
}
p.pt <- function(x, df, ncp = 0, lower.tail = TRUE, log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_pt_v", x, df, lower.tail, log.p, P)
    else .Call("do_pnt_v", x, df, ncp, lower.tail, log.p, P)
}
p.qt <- function(p, df, ncp = 0, lower.tail = TRUE, log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_qt_v", p, df, lower.tail, log.p, P)
    else .Call("do_qnt_v", p, df, ncp, lower.tail, log.p, P)
}
    
if (FALSE) { #  not thread-safe
    DEFMATH_2_1(dsignrank)
    DEFMATH_2_2(psignrank)
    DEFMATH_2_2(qsignrank)

    DEFMATH_2(bessel_j)
    DEFMATH_2(bessel_y)
}

p.psigamma <- function(x, deriv = 0, P = 0) .Call("do_psigamma_v", x, deriv, P)


## Math 3 Group

p.dbeta <- function(x, shape1, shape2, ncp = 0, log = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_dbeta_v", x, shape1, shape2, log, P)
    else .Call("do_dnbeta_v", x, shape1, shape2, ncp, log, P)
}
p.pbeta <- function(x, shape1, shape2, ncp = 0, lower.tail = TRUE,
                    log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_pbeta_v", x, shape1, shape2, lower.tail, log.p, P)
    else .Call("do_pnbeta_v", x, shape1, shape2, ncp, lower.tail, log.p, P)
}
p.qbeta <- function(p, shape1, shape2, ncp = 0, lower.tail = TRUE,
                    log.p = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_qbeta_v", p, shape1, shape2, lower.tail, log.p, P)
    else .Call("do_qnbeta_v", p, shape1, shape2, ncp, lower.tail, log.p, P)
}

p.dbinom <- function(x, size, prob, log = FALSE, P = 0)
    .Call("do_dbinom_v", x, size, prob, log, P)
p.pbinom <- function(x, size, prob, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_pbinom_v", x, size, prob, lower.tail, log.p, P)
p.qbinom <- function(p, size, prob, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_qbinom_v", p, size, prob, lower.tail, log.p, P)

p.dcauchy <- function(x, location = 1, scale = 1, log = FALSE, P = 0)
    .Call("do_dcauchy_v", x, location, scale, log, P)
p.pcauchy <- function(x, location = 1, scale = 1, lower.tail = TRUE,
                      log.p = FALSE, P = 0)
    .Call("do_pcauchy_v", x, location, scale, lower.tail, log.p, P)
p.qcauchy <- function(p, location = 1, scale = 1, lower.tail = TRUE,
                      log.p = FALSE, P = 0)
    .Call("do_qcauchy_v", p, location, scale, lower.tail, log.p, P)

p.df <- function(x, df1, df2, ncp = 0, log = FALSE, P = 0) {
    if (missing(ncp))
        .Call("do_df_v", x, df1, df2, log, P)
    else .Call("do_dnf_v", x, df1, df2, ncp, log, P)
}
p.pf <- function(x, df1, df2, ncp = 0, lower.tail = TRUE, log.p = FALSE,
                 P = 0) {
    if (missing(ncp))
        .Call("do_pf_v", x, df1, df2, lower.tail, log.p, P)
    else .Call("do_pnf_v", x, df1, df2, ncp, lower.tail, log.p, P)
}
p.qf <- function(p, df1, df2, ncp = 0, lower.tail = TRUE, log.p = FALSE,
                 P = 0) {
    if (missing(ncp))
        .Call("do_qf_v", p, df1, df2, lower.tail, log.p, P)
    else .Call("do_qnf_v", p, df1, df2, ncp, lower.tail, log.p, P)
}

p.dgamma <- function(x, shape, rate = 1, scale = 1/rate, log=FALSE, P = 0)
    .Call("do_dgamma_v", x, shape, rate, log, P)
p.pgamma <- function(x, shape, rate = 1, scale = 1/rate, lower.tail = TRUE,
                     log.p=FALSE, P = 0)
    .Call("do_pgamma_v", x, shape, rate, lower.tail, log.p, P)
p.qgamma <- function(p, shape, rate = 1, scale = 1/rate, lower.tail = TRUE,
                     log.p=FALSE, P = 0)
    .Call("do_qgamma_v", p, shape, rate, lower.tail, log.p, P)

p.dlnorm <- function(x, meanlog = 0, sdlog = 1, log = FALSE, P = 0)
    .Call("do_dlnorm_v", x, meanlog, sdlog, log, P)
p.plnorm <- function(x, meanlog = 0, sdlog = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_plnorm_v", x, meanlog, sdlog, lower.tail, log.p, P)
p.qlnorm <- function(p, meanlog = 0, sdlog = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_qlnorm_v", p, meanlog, sdlog, lower.tail, log.p, P)

p.dlogis <- function(x, location = 0, scale = 1, log = FALSE, P = 0)
    .Call("do_dlogis_v", x, location, scale, log, P)
p.plogis <- function(x, location = 0, scale = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_plogis_v", x, location, scale, lower.tail, log.p, P)
p.qlogis <- function(p, location = 0, scale = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_qlogis_v", p, location, scale, lower.tail, log.p, P)

p.dnbinom <- function(x, size, prob, mu, log = FALSE, P = 0) {
    if (!missing(mu)) {
        if (!missing(prob))
            stop("'prob' and 'mu' both specified")
        prob <- size/(size + mu)
    }
    .Call("do_dnbinom_v", x, size, prob, log, P)
}
p.pnbinom <- function(x, size, prob, mu, lower.tail = TRUE, log.p = FALSE,
                      P = 0) {
    if (!missing(mu)) {
        if (!missing(prob))
            stop("'prob' and 'mu' both specified")
        prob <- size/(size + mu)
    }
    .Call("do_pnbinom_v", x, size, prob, lower.tail, log.p, P)
}
p.qnbinom <- function(p, size, prob, mu, lower.tail = TRUE, log.p = FALSE,
                      P = 0) {
    if (!missing(mu)) {
        if (!missing(prob))
            stop("'prob' and 'mu' both specified")
        prob <- size/(size + mu)
    }
    .Call("do_qnbinom_v", p, size, prob, lower.tail, log.p, P)
}

p.dnorm <- function(x, mean = 0, sd = 1, log = FALSE, P = 0)
    .Call("do_dnorm_v", x, mean, sd, log, P)
p.pnorm <- function(x, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE,
                    P = 0)
    .Call("do_pnorm_v", x, mean, sd, lower.tail, log.p, P)
p.qnorm <- function(p, mean = 0, sd = 1, lower.tail = TRUE, log.p = FALSE,
                    P = 0)
    .Call("do_qnorm_v", p, mean, sd, lower.tail, log.p, P)

p.dunif <- function (x, min = 0, max = 1, log = FALSE, P = 0)
    .Call("do_dunif_v", x, min, max, log, P)
p.punif <- function (x, min = 0, max = 1, lower.tail = TRUE, log.p = FALSE,
                     P = 0)
    .Call("do_punif_v", x, min, max, lower.tail, log.p, P)
p.qunif <- function (p, min = 0, max = 1, lower.tail = TRUE, log.p = FALSE,
                     P = 0)
    .Call("do_qunif_v", p, min, max, lower.tail, log.p, P)

p.dweibull <- function(x, shape, scale = 1, log = FALSE, P = 0)
    .Call("do_dweibull_v", x, shape, scale, log, P)
p.pweibull <- function(x, shape, scale = 1, lower.tail = TRUE, log.p = FALSE,
                       P = 0)
    .Call("do_pweibull_v", x, shape, scale, lower.tail, log.p, P)
p.qweibull <- function(p, shape, scale = 1, lower.tail = TRUE, log.p = FALSE,
                       P = 0)
    .Call("do_qweibull_v", p, shape, scale, lower.tail, log.p, P)

if (FALSE) { # not thread-safe
  DEFMATH_3_1(dwilcox)
  DEFMATH_3_2(pwilcox)
  DEFMATH_3_2(qwilcox)

  DEFMATH3(bessel_i)
  DEFMATH3(bessel_k)
}


## Math 4 Group

p.dhyper <- function(x, m, n, k, log = FALSE, P = 0)
    .Call("do_dhyper_v", x, m, n, k, log, P)
p.phyper <- function(x, m, n, k, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_phyper_v", x, m, n, k, lower.tail, log.p, P)
p.qhyper <- function(p, m, n, k, lower.tail = TRUE, log.p = FALSE, P = 0)
    .Call("do_qhyper_v", p, m, n, k, lower.tail, log.p, P)

if (FALSE) { # not implemented
    DEFMATH_4_1(dtukey)
}

p.ptukey <- function(x, nmeans, df, nranges = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_ptukey_v", x, nranges, nmeans, df, lower.tail, log.p, P)
p.qtukey <- function(p, nmeans, df, nranges = 1, lower.tail = TRUE,
                     log.p = FALSE, P = 0)
    .Call("do_qtukey_v", p, nranges, nmeans, df, lower.tail, log.p, P)
